///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define IDM_Settings   1000
#define IDM_ViewLog    1001
#define IDM_Backup     1002
#define IDM_Restore    1003
#define IDM_MaintSched 1004
#define IDM_HoldSched  1005
#define IDM_ViewSched  1006
#define IDM_About      1007
#define IDM_Close      1008

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define ID_MYTOOLBAR   2000

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define BTIcons        9
#define TBButtons      12
#define TBLength       36
#define TBWidth        36

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

TBBUTTON tbb[] = {
    {0, IDM_Settings, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {1, IDM_ViewLog, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},

    {0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0},

    {2, IDM_Backup, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {3, IDM_Restore, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},

    {0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0},

    {4, IDM_MaintSched, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {8, IDM_HoldSched, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {5, IDM_ViewSched, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},

    {0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0},

    {6, IDM_About, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {7, IDM_Close, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0}
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HWND CreateToolBar(HWND hWnd)
{
    HWND hTool     = NULL;
    HBITMAP BitMap = NULL;

    InitCommonControls();

    if(! (BitMap = LoadBitmap(MainInstance, MAKEINTRESOURCE(ToolBarBitmap) )) )
        ErrorMessage(hWnd, "Failed to load bitmap");

    hTool = CreateToolbarEx(
        hWnd,
        WS_CHILD | WS_VISIBLE |TBSTYLE_TOOLTIPS|TBSTYLE_FLAT|TBSTYLE_TOOLTIPS,
        ID_MYTOOLBAR,
        BTIcons,
        NULL,
        (DWORD)BitMap,
        tbb,
        0,
        TBLength, TBWidth,
        0, 0,
        sizeof(TBBUTTON)
    );

    tbb[0].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"Configure");
    tbb[1].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"View Log");

    tbb[3].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"Backup");
    tbb[4].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"Restore");

    tbb[6].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"Add Job");
    tbb[7].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"Halt Jobs");
    tbb[8].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"View Jobs");

    tbb[10].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"Help");
    tbb[11].iString = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM)"Close");

    SendMessage(hTool, TB_ADDBUTTONS, TBButtons, (LONG)&tbb);
    SendMessage(hTool, TB_AUTOSIZE, 0, 0);

    return hTool;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK JobManagerDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HMENU SystemMenu   = NULL;
    static HWND  MainToolBar  = NULL;

    //--------------------------------------------------------------------------

    if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        JobManagerDialog_hWnd = xHandle;

        SystemMenu = GetSystemMenu(JobManagerDialog_hWnd, FALSE);
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1000, "About");
        AppendMenu(SystemMenu, MF_STRING, 1001, "Version");
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1002, "www.NetWorkDLS.com");

        SendMessage(JobManagerDialog_hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)TitleCaption);
        SendMessage(JobManagerDialog_hWnd, WM_SETICON, TRUE, (LPARAM)LoadIcon(MainInstance, MAKEINTRESOURCE(DialogIcon)) );

        MainToolBar = CreateToolBar(JobManagerDialog_hWnd);

        StatusListBox_hWnd = GetDlgItem(JobManagerDialog_hWnd, 1000);

        if(AllOnHold == TRUE)
            SendMessage(MainToolBar, (UINT)TB_CHECKBUTTON, (WPARAM)IDM_HoldSched, (LPARAM)MAKELONG (TRUE, 0));

        if(AllOnHold == FALSE)
            SendMessage(MainToolBar, (UINT)TB_CHECKBUTTON, (WPARAM)IDM_HoldSched, (LPARAM)MAKELONG (FALSE, 0));

        LoadJobHistory(StatusListBox_hWnd);

        RECT ThisRect;
        GetWindowRect(JobManagerDialog_hWnd, &ThisRect);
        MoveWindow(StatusListBox_hWnd, 0, 70, ThisRect.right, ThisRect.bottom, TRUE);

        CenterWindow(JobManagerDialog_hWnd);

        StartupComplete = TRUE;

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_SIZE ) // Received A Message
    {
        int nWidth = LOWORD(lParam);
        int nHeight = HIWORD(lParam);
        MoveWindow(StatusListBox_hWnd, 0, 70, nWidth, nHeight, TRUE);
        SendMessage(MainToolBar, TB_AUTOSIZE, 0, 0);
        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_COMMAND) // Received A Message
    {
        if(wParam==IDM_Settings) //- Options (Dialog Menu Command)
        {
            if( IsWinNT() )
            {
                DialogBox(MainInstance, MAKEINTRESOURCE(wNTOptions), JobManagerDialog_hWnd, wNTOptionsDialog);
            }
            else{
                DialogBox(MainInstance, MAKEINTRESOURCE(w9xOptions), JobManagerDialog_hWnd, w9xOptionsDialog);
            }

            return 0;
        }

        if(wParam==IDM_ViewLog) //- Job log (Dialog Menu Command)
        {
            DialogBox(MainInstance, MAKEINTRESOURCE(ViewLog), JobManagerDialog_hWnd, ViewLogDialog);
            return 0;
        }

        if(wParam==IDM_Close) //- Close (Dialog Menu Command)
        {
            EndDialog(JobManagerDialog_hWnd,0);
            return 0;
        }

        if(wParam==IDM_Backup) //- Manual Backup (Dialog Menu Command)
        {
        	DialogBox(MainInstance, MAKEINTRESOURCE(ManBackup), JobManagerDialog_hWnd, ManBackupDialog);
            return 0;
        }
        if(wParam==IDM_Restore) //- Manual Restore (Dialog Menu Command)
        {
        	DialogBox(MainInstance, MAKEINTRESOURCE(ManRestore), JobManagerDialog_hWnd, ManRestoreDialog);
            return 0;
        }

        if(wParam==IDM_MaintSched) //- Maintain Schedule (Dialog Menu Command)
        {
            if(CurrentlyRunning == TRUE)
            {
                MessageBox(JobManagerDialog_hWnd, "Please wait untill the current process has completed.", TitleCaption, MB_TASKMODAL);
                return 0;
            }

            if(AllOnHold == TRUE)
            {
                DialogBox(MainInstance, MAKEINTRESOURCE(MaintainSchedule), JobManagerDialog_hWnd, ScheduleDialog);
            }
            else{
                AllOnHold = TRUE;
                DialogBox(MainInstance, MAKEINTRESOURCE(MaintainSchedule), JobManagerDialog_hWnd, ScheduleDialog);
                AllOnHold = FALSE;
            }
            return 0;
        }

        if(wParam==IDM_ViewSched) //- View Schedule (Dialog Menu Command)
        {
            DialogBox(MainInstance, MAKEINTRESOURCE(ViewSchedule), JobManagerDialog_hWnd, ViewScheduleDialog);

            return 0;
        }

        if(wParam==IDM_HoldSched) //- On Hold (Dialog Menu Command)
        {
            if(AllOnHold == TRUE)
            {
                SendMessage(MainToolBar, (UINT)TB_CHECKBUTTON, (WPARAM)IDM_HoldSched, (LPARAM)MAKELONG (FALSE, 0));
                AllOnHold = FALSE;
                return 0;
            }

            if(AllOnHold == FALSE)
            {
                SendMessage(MainToolBar, (UINT)TB_CHECKBUTTON, (WPARAM)IDM_HoldSched, (LPARAM)MAKELONG (TRUE, 0));
                AllOnHold = TRUE;
                return 0;
            }

            return 0;
        }

        if(wParam==IDM_About) //- About (Dialog Menu Command)
        {
            NetLogo(JobManagerDialog_hWnd);
            return 0;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            NetLogo(JobManagerDialog_hWnd);
            return 0;
        }

        if(LOWORD(wParam) == 1001) //- Version (SysMenu Command)
        {
            char VersionText[128];
            sprintf(VersionText, "%s, Version %s", TitleCaption, FileVersion);
            MessageBox(JobManagerDialog_hWnd, VersionText, "Application Version", MB_TASKMODAL);
            return 0;
        }

        if(LOWORD(wParam) == 1002) //- www.NetWorkDLS.com (SysMenu Command)
        {
            ShellExecute(0,"Open", "Http://www.NetWorkDLS.com", NULL, NULL, SW_SHOWNORMAL);
            return 0;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_CLOSE)  // Received Close Message
    {
        EndDialog(JobManagerDialog_hWnd,0);
        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_DESTROY) // Received Destroy Message
    {
//        PostQuitMessage(0);
        return 0;
    }

    //--------------------------------------------------------------------------

    return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

